<?php
namespace Financeiro\Logic\ContasReceber\Boleto\ParcelarBoleto;
use \Financeiro\Logic\ContasReceber\Boleto\OperacoesBoleto;
use \Financeiro\Entities\GeralRec;
use \Financeiro\Entities\Ajbolrec;
use \Financeiro\Logic\ContasReceber\Boleto\ParcelarBoleto\ExcecaoParcelamento;
use \Geral\Util\DateUtil;
use \Financeiro\Logic\ContasReceber\Boleto\Exception\ExcecaoCnab;
/**
 * Created by JetBrains PhpStorm.
 * User: alanoliveira
 * Date: 02/09/13
 * Time: 14:28
 * To change this template use File | Settings | File Templates.
 */
class ValidacaoParcelamento
{
       public static function Valida(\Financeiro\Entities\Boletreceber $boleto){

        try {

             if (self::VerificaAjuste($boleto))
                ExcecaoParcelamento::Parc_bloq_bol_possui_ajuste();

             if($boleto->getIdstatbrec() == 'B')
                 ExcecaoParcelamento::parc_ja_baixada();
             
             if ($boleto->getIdstatbrec() == 'E')
                 ExcecaoParcelamento::parc_emit();
             
             if ((bool)$boleto->getNrcnabrecrem() === true) 
                 ExcecaoCnab::Cnab_N_Alterado();
    
        }catch (\Exception $e) {
           throw $e;
        }

    }

   private function VerificaAjuste(\Financeiro\Entities\Boletreceber $boleto){
       return (bool) Ajbolrec::findOneByCdfilialAndNrlanbolrecAndNrorg($boleto->getCdfilial(),
                                                                       $boleto->getNrlanbolrec(),
                                                                       $boleto->getNrorg());
   }

    public static function ValidaSomaParcelasMaior(array $parcelas, $valor_total_boleto){
        try{

            //Verificação do numero da última parcela salva
            $parcelasalvas = tk_get_env_var('COPIA_PARCELAS_DO_BOLETO');
            $nrultparc = count($parcelasalvas);


            $soma = 0;
            foreach ($parcelas as $parcela){
                if ((int)$parcela['NRPARCBOLREC'] >= $nrultparc)
                $soma += $parcela['VRFINALBREC'];
            }
            if($soma >$valor_total_boleto)
            {
                //utilizado para abortar a operacão do new row
                tk_abort(tk_get_message_by_name('msg_parc_inv'));
            }
        }
        catch (\Exception $e){
            throw $e;
        }
    }

    public static function ValidaSomaParcelasDif(array $parcelas, $valor_total_boleto){
        try{

            //Verificação do numero da última parcela salva
            $parcelasalvas = tk_get_env_var('COPIA_PARCELAS_DO_BOLETO');
            $nrultparc = count($parcelasalvas);

            $soma = 0;
            foreach ($parcelas as $parcela){
                if ((int)$parcela['NRPARCBOLREC'] >= $nrultparc)
                $soma += $parcela['VRFINALBREC'];
            }            
            if(round($soma) != round($valor_total_boleto))
               ExcecaoParcelamento::valor_parc_inv();
        }
        catch (\Exception $e){
            throw $e;
        }
    }

    //Data das parcelas devem estar de acordo com os numeros das mesmas
    //Ex: 01 - 01/01/2011   02 - 01/01/2010 = ERRO
    public static function ValidaDatas(array $parcelas){

        try {
            if(count($parcelas)>1)
            {
                $data1 = null;
                foreach ($parcelas as $parcela) {
                    if ($data1 == null){
                       $data1 = $parcela['DTVENBOLREC'];
                        if ((bool)$data1 instanceof \Doctrine2\DBAL\Types\DateType === false){
                            if(strlen($data1)>10){
                               $data1 = DateUtil::truncateString($data1);
                            }
                            $data1 = DateUtil::getDataDeString($data1);
                        }
                    }

                    $data2 = $parcela['DTVENBOLREC'];
                    if ((bool)$data2 instanceof \Doctrine2\DBAL\Types\DateType === false){
                       if(strlen($data2)>10){
                            $data2 = DateUtil::truncateString($parcela['DTVENBOLREC']);
                        }
                        $data2 = DateUtil::getDataDeString($data2);
                   }

                    if (DateUtil::comparaDatas(DateUtil::truncateData($data1),
                                               DateUtil::truncateData($data2),2)){
                        tk_set_field_value('DTVENBOLREC',null);
                        ExcecaoParcelamento::data_parc_inv();
                    }
                    else
                    {   $data1 = $parcela['DTVENBOLREC'];
                        if ((bool)$data1 instanceof \Doctrine2\DBAL\Types\DateType === false){
                            if(strlen($data1)>10)
                                $data1 = DateUtil::truncateString($data1);
                             $data1 = DateUtil::getDataDeString($data1);
                        }
                    }
                }
            }
        } catch (\Exception $e) {
            throw $e;
        }
   }
}
