/* Sistemas Integrados TECNISA
   Servios

Nome: TAREFA_POR_SOLICITACAO

Descrio:
Clculo das datas e horas previstas para incio e concluso das tarefas dos
funcionrios de uma solicitao.

P_CDFILIAL   - Cdigo da Filial
P_NRSOLISERV - Nmero da Solicitao

Para aplicar e debugar
-- @H:\SISTEMAS\DBA\SQL\ORACLE\7210_SRVSTP_TAREFA_POR_SOLICITACAO.sql;
-- EXECUTE TAREFA_POR_SOLICITACAO('9999', '01', '0000001001')
-- SET SERVEROUTPUT ON
-- DBMS_OUTPUT.PUT_LINE('xx');

Criao:
11/12/99 - Ederson

*/

CREATE OR REPLACE
PROCEDURE TAREFA_POR_SOLICITACAO
  (P_CDFILIAL   IN VARCHAR2,
   P_NRSOLISERV IN VARCHAR2) IS

   V_CDOPERRESP VARCHAR2(12);

   CURSOR C_FUNC_TAREFAS IS
      SELECT DISTINCT
         CDOPERRESP
      FROM
         TARESERV
      WHERE
         (CDFILIAL   = P_CDFILIAL) AND
         (NRSOLISERV = P_NRSOLISERV)
      ORDER BY
         CDOPERRESP;

BEGIN
   OPEN C_FUNC_TAREFAS;
   LOOP
      FETCH C_FUNC_TAREFAS
      INTO V_CDOPERRESP;
      EXIT WHEN C_FUNC_TAREFAS%NOTFOUND;
      TAREFA_POR_FUNCIONARIO(P_CDFILIAL, V_CDOPERRESP);
   END LOOP;
   CLOSE C_FUNC_TAREFAS;
END;
/

